% Problem 2

% Parameters
rhomax=1.0;
rhoL=rhomax/2;
umax=1.0;
dx=4/400;
dt=0.8*dx/umax;
nt=10.0/dt;

% Grid and initial conditions
x=-2:dx:2;
rho=rhoL*(x<0.0);

% Period, number of timesteps
T=2.0/dt;

% Average flow and initial state
qdot=0.0;
red=1;

% Main loop
for it=1:nt
  % Flux
  f=rho*umax.*(1-rho/rhomax);
  minf=min(f(1:end-1),f(2:end));
  maxf=max(f(1:end-1),f(2:end));
  maxf((rho(1:end-1)-0.5).*(rho(2:end)-0.5)<0)=rhomax*umax/4;
  F=minf.*(rho(1:end-1)<rho(2:end))+ ...
    maxf.*(rho(1:end-1)>=rho(2:end));

  % Red light
  if red
    F(size(F,2)/2)=0;
  end
  
  % Update solution
  rho(2:end-1)=rho(2:end-1)-dt/dx*(F(2:end)-F(1:end-1));

  % Update average flow
  qdot=qdot+f(size(F,2)/2);

  % Switch state?
  if mod(it,T/2)==0
    if red==0
      disp(['Average flow = ',num2str(qdot/T)]);
      qdot=0.0;
      red=1;
    else
      red=0;
    end
  end
  
  % Plot
  plot(x,rho,'.')
  axis([-2,2,0,1])
  grid on
  drawnow
end
