% Problem 3

% Parameters
rhomax=1.0;
rhoL=rhomax/2;;
umax=1.0;
dx=4/400;
dt=0.8*dx/umax;
nt=10.0/dt;

% Period, number of timesteps
T=2.0/dt;

% Test cases
for k=0:9
  disp(' ')
  disp(['k = ',int2str(k)])
  disp('-----')

  % tau, number of timesteps
  tau=k/10*T;
  
  % Grid and initial conditions
  x=-2:dx:2;
  rho=rhoL*(x<0.0);

  % Average flow and initial states
  qdot=0.0;
  red1=1;
  red2=tau>T/2|tau==0;

  % Main loop
  for it=1:nt
    % Flux
    f=rho*umax.*(1-rho/rhomax);
    minf=min(f(1:end-1),f(2:end));
    maxf=max(f(1:end-1),f(2:end));
    maxf((rho(1:end-1)-0.5).*(rho(2:end)-0.5)<0)=rhomax*umax/4;
    F=minf.*(rho(1:end-1)<rho(2:end))+ ...
      maxf.*(rho(1:end-1)>=rho(2:end));

    % Red lights
    if red1
      F(size(F,2)/2)=0;
    end
    if red2
      F(size(F,2)/2+.15/dx)=0;
    end
    
    % Update solution
    rho(2:end-1)=rho(2:end-1)-dt/dx*(F(2:end)-F(1:end-1));

    % Update average flow
    qdot=qdot+f(size(F,2)/2);

    % Switch states?
    if mod(it,T/2)==0
      if red1==0
        disp(['Average flow = ',num2str(qdot/T)]);
        qdot=0.0;
        red1=1;
      else
        red1=0;
      end
    end
    if mod(it-tau,T/2)==0
      if red2==0
        red2=1;
      else
        red2=0;
      end
    end

    % Plot
    plot(x,rho,'.')
    axis([-2,2,0,1])
    grid on
    drawnow
  end
end
